//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     DeepPink
#property indicator_color3     Gold
#property indicator_width1     2
#property indicator_width2     2
#property indicator_style3     STYLE_DASH

//
//
//
//
//

extern int    Price           = 0;
extern double ItPeriod        = 20;
extern int    MaMethod        = MODE_EMA;
extern int    LevelBars       = 300;
extern double LevelFactor     = 0.283;

//
//
//
//
//

double Upval[];
double Dnval[];
double ItLev[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
      IndicatorBuffers(4);
      SetIndexBuffer(0,Upval); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,Dnval); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ItLev);
      SetIndexBuffer(3,trend);
      
      IndicatorShortName("ITrend");
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for (i=limit-1; i>=0; i--)
      {  
         double ma = iMA(NULL,0,1,0,MaMethod,Price,i);
         Upval[i]  = ma        - iMA(NULL,0,ItPeriod,0,MaMethod,Price,i);
         Dnval[i]  = - (Low[i] - iMA(NULL,0,ItPeriod,0,MaMethod,Price,i)
                     +  High[i]- iMA(NULL,0,ItPeriod,0,MaMethod,Price,i));
                     
         double hi = MathMax(Upval[ArrayMaximum(Upval,LevelBars,i)],Dnval[ArrayMaximum(Dnval,LevelBars,i)]);
         ItLev[i]  = hi*LevelFactor; 
         trend[i]  = trend[i+1]; 
         
	      if (Upval[i] > ItLev[i]) trend[i]= 1; 
	      if (Dnval[i] > ItLev[i]) trend[i]=-1;
       }  
   
       SetLevelValue(0,ItLev[0]);
     return(0);
    }

    